function [rdata1,rdata2]=shokuyo_ME3get
persistent data timestamp timestamp2;
if(isempty(timestamp));
  timestamp = 0;
  timestamp2 = 0;
end;
timeout=timestamp-timestamp2;
if(timeout > 400) data=[];end
for i=1:100000;
  data=[data,rs232cj2([])];
  if(length(data) < 5);
    pause(.05);
    continue;
  end;
  idx10 = strfind(data,[10,10]);
  if(length(idx10)>1);break;end;
end;
if(i == 100000) fprintf('time out\n');end;
%ME0000108001000 retmessage
%99b             99b
%00G:Q           timestamp+ sum
%0:50\e0:50];0:G0]I0:O0]D0:O0]20:O0\h0:O0]X0:O0^80:O0]i0:S0^=0:S0^
%\P0:S0W`0:H0NH0:H0I?0:A0Kn0:A0UV0:E0\E0:I0^a0:I0\c0:V0X=0:V0Sc0:U

data2=data((idx10(1)+2):(idx10(2)-2));idx2 = strfind(data2,10);
data=data(idx10(2):end);

timestamp=sum([data2((idx2(2)+1):(idx2(3)-2))-48].*64.^(3:-1:0));

%Parameters for UTM-30LX
DMIN=23;DMAX=60000;ARES=1440;AMIN=0;AMAX=1080;AFRT=540;SCAN=2400;

llen=AMAX-AMIN+1;
datasize=llen * 6;
datalen=floor(datasize/64);
rdata=zeros(1,datasize);
for i=1:datalen;
  dat = data2((idx2(i+2)+1):(idx2(i+3)-2));
  if(data2(idx2(i+3)-1)==bitand(sum(dat),63)+48);
    rdata((i-1)*64+(1:64))=dat-48;
  else fprintf('Invalid data %s\n',char(dat));end
end;
rdata((datasize-mod(datasize,64)+1):datasize)=data2((idx2(datalen+3)+1):end)-48;
rdata=reshape(rdata(1:datasize),6,llen);
dummy = 2.^(12:-6:0)' * ones(1,llen);
rdata1=sum(rdata(1:3,:).* dummy)/1000;
rdata2=sum(rdata(4:6,:).* dummy)/1000;
