function [rdata1]=shokuyo_MDget
persistent data timestamp timestamp2;
if(isempty(timestamp));
  timestamp = 0;
  timestamp2 = 0;
end;
timeout=timestamp-timestamp2;
if(timeout > 200) data=[];end;
for i=1:100000;
  data=[data,rs232cj2([])];
  if(length(data) < 5);
    pause(.05);
    continue;
  end;
  idx10 = strfind(data,[10,10]);
  if(length(idx10)>1);break;end;
end;
if(i == 100000) fprintf('time out\n');end;
%ME0000108001000 retmessage
%99b             99b
%00G:Q           timestamp+ sum
%0:50\e0:50];0:G0]I0:O0]D0:O0]20:O0\h0:O0]X0:O0^80:O0]i0:S0^=0:S0^
%\P0:S0W`0:H0NH0:H0I?0:A0Kn0:A0UV0:E0\E0:I0^a0:I0\c0:V0X=0:V0Sc0:U

data=data((idx10(1)+2):end);idx10 = strfind(data,10);
retmessage=char(data(1:idx10(1))); % ME0000108001000
data=data((idx10(1)+1):end);idx10 = strfind(data,10);
if(data(idx10(1)-1)==bitand(sum(data(1:(idx10(1)-2))),63)+hex2dec('30'));
status=char(data(1:(idx10(1)-2))); % 99
else fprintf('[status check]InValid data %s\n',char(data(1:(idx10(1)-2))));end
data=data((idx10(1)+1):end);idx10 = strfind(data,10);
if(data(idx10(1)-1)==bitand(sum(data(1:(idx10(1)-2))),63)+hex2dec('30'));
  timestamp2 = timestamp;
  timestamp=sum([data(1:4)-48].*64.^(3:-1:0));
else fprintf('InValid data %s\n',char(data(1:(idx10(1)-2))));end
data=data((idx10(1)+1):end);idx10 = strfind(data,10);

%Parameters for UTM-30LX
DMIN=23;DMAX=60000;ARES=1440;AMIN=0;AMAX=1080;AFRT=540;SCAN=2400;

%Parameters for URG-04LX-UG01
%DMIN=20;DMAX=5600;ARES=1024;AMIN=44;AMAX=725;AFRT=384;SCAN=600;

llen = AMAX - AMIN + 1;
datasize=llen * 3;
idx10=[0,idx10];
datalen=floor(datasize/64);
rdata=zeros(1,datasize);
for i=1:datalen
  dat = data((idx10(i)+1):(idx10(i+1)-2));
  if(data(idx10(i+1)-1)==bitand(sum(dat),63)+48);
    rdata((i-1)*64+(1:64))=dat-48;
  else fprintf('InValid data %s\n',char(dat));end;
end;
rdata((datasize-mod(datasize,64)+1):datasize)=data((idx10(datalen+1)+1):(idx10(datalen+2)-2))-48;

data=data((idx10(datalen+2)+1):end);
rdata=reshape(rdata(1:datasize),3,llen);
dummy = 2.^(12:-6:0)' * ones(1,llen);
rdata1=sum(rdata(1:3,:).* dummy)/1000;
